/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.47 Revision 1.69
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.47 2007/08/14 14:47:21 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.69 2009/03/24 21:10:13 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
71 71
72# works in most cases 72# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 74
75# depend on headers for DVB-driver 75# depend on headers for DVB-driver
76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1" 76COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77
78DEPEND="${COMMON_DEPEND}
77DEPEND="media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
80RDEPEND="${COMMON_DEPEND}
81 >=app-admin/eselect-vdr-0.0.2"
78 82
79 83# this is a hack for ebuilds like vdr-xineliboutput that want to
80# this code is from linux-mod.eclass 84# conditionally install a vdr-plugin
81update_vdrplugindb() { 85if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 86 # make DEPEND conditional
83 87 IUSE="${IUSE} vdr"
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then 88 DEPEND="vdr? ( ${DEPEND} )"
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR} 89 RDEPEND="vdr? ( ${RDEPEND} )"
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi 90fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92}
93
94remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi
101}
102 91
103# New method of storing plugindb 92# New method of storing plugindb
104# Called from src_install 93# Called from src_install
105# file maintained by normal portage-methods 94# file maintained by normal portage-methods
106create_plugindb_file() { 95create_plugindb_file() {
107 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 96 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
108 local DB_FILE=${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 97 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
109 insinto ${NEW_VDRPLUGINDB_DIR} 98 insinto "${NEW_VDRPLUGINDB_DIR}"
99
100# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
110 cat <<-EOT > ${D}/${DB_FILE} 101# cat <<-EOT > "${D}/${DB_FILE}"
111 VDRPLUGIN_DB=1 102# VDRPLUGIN_DB=1
112 CREATOR=ECLASS 103# CREATOR=ECLASS
113 EBUILD=${CATEGORY}/${PN} 104# EBUILD=${CATEGORY}/${PN}
114 EBUILD_V=${PVR} 105# EBUILD_V=${PVR}
115 EOT 106# EOT
107 {
108 echo "VDRPLUGIN_DB=1"
109 echo "CREATOR=ECLASS"
110 echo "EBUILD=${CATEGORY}/${PN}"
111 echo "EBUILD_V=${PVR}"
112 echo "PLUGINS=\"$@\""
113 } > "${D}/${DB_FILE}"
116} 114}
117 115
118# Delete files created outside of vdr-plugin.eclass 116# Delete files created outside of vdr-plugin.eclass
119# vdrplugin-rebuild.ebuild converted plugindb and files are 117# vdrplugin-rebuild.ebuild converted plugindb and files are
120# not deleted by portage itself - should only be needed as 118# not deleted by portage itself - should only be needed as
121# long as not every system has switched over to 119# long as not every system has switched over to
122# vdrplugin-rebuild-0.2 120# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
123delete_orphan_plugindb_file() { 121delete_orphan_plugindb_file() {
124 #elog Testing for orphaned plugindb file 122 #elog Testing for orphaned plugindb file
125 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 123 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
126 local DB_FILE=${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 124 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
127 125
128 # file exists 126 # file exists
129 [[ -f ${DB_FILE} ]] || return 127 [[ -f ${DB_FILE} ]] || return
130 128
131 # will portage handle the file itself 129 # will portage handle the file itself
132 if grep -q CREATOR=ECLASS ${DB_FILE}; then 130 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
133 #elog file owned by eclass - don't touch it 131 #elog file owned by eclass - don't touch it
134 return 132 return
135 fi 133 fi
136 134
137 elog "Removing orphaned plugindb-file." 135 elog "Removing orphaned plugindb-file."
138 elog "\t#rm ${DB_FILE}" 136 elog "\t#rm ${DB_FILE}"
139 rm ${DB_FILE} 137 rm "${DB_FILE}"
140} 138}
141 139
142 140
143create_header_checksum_file() 141create_header_checksum_file()
144{ 142{
145 # Danger: Not using $ROOT here, as compile will also not use it !!! 143 # Danger: Not using $ROOT here, as compile will also not use it !!!
146 # If vdr in $ROOT and / differ, plugins will not run anyway 144 # If vdr in $ROOT and / differ, plugins will not run anyway
147 145
148 insinto ${VDR_CHECKSUM_DIR} 146 local CHKSUM="header-md5-vdr"
147
149 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 148 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
150 newins ${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN} 149 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
150 elif type -p md5sum >/dev/null 2>&1; then
151 (
152 cd "${VDR_INCLUDE_DIR}"
153 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
154 ) > "${CHKSUM}"
151 else 155 else
152 if type -p md5sum >/dev/null 2>&1; then 156 die "Could not create md5 checksum of headers"
153 cd ${S} 157 fi
154 ( 158
155 cd ${VDR_INCLUDE_DIR} 159 insinto "${VDR_CHECKSUM_DIR}"
156 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 160 local p_name
157 ) > header-md5-${PN} 161 for p_name; do
158 doins header-md5-${PN} 162 newins "${CHKSUM}" "header-md5-${p_name}"
163 done
164}
165
166fix_vdr_libsi_include()
167{
168 einfo "Fixing include of libsi-headers"
169 local f
170 for f; do
171 sed -i "${f}" \
172 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
173 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
174 done
175}
176
177vdr_patchmakefile() {
178 einfo "Patching Makefile"
179 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
180 cp Makefile "${WORKDIR}"/Makefile.before
181
182 # plugin makefiles use VDRDIR in strange ways
183 # assumptions:
184 # 1. $(VDRDIR) contains Make.config
185 # 2. $(VDRDIR) contains config.h
186 # 3. $(VDRDIR)/include/vdr contains the headers
187 # 4. $(VDRDIR) contains main vdr Makefile
188 # 5. $(VDRDIR)/locale exists
189 # 6. $(VDRDIR) allows to access vdr source files
190 #
191 # We only have one directory (for now /usr/include/vdr),
192 # that contains vdr-headers and Make.config.
193 # To satisfy 1-3 we do this:
194 # Set VDRDIR=/usr/include/vdr
195 # Set VDRINCDIR=/usr/include
196 # Change $(VDRDIR)/include to $(VDRINCDIR)
197
198 ebegin " Setting paths"
199 sed -i Makefile \
200 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
201 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
202 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
203 \
204 -e 's:-I$(DVBDIR)/include::' \
205 -e 's:-I$(DVBDIR)::'
206 eend 0
207
208 # maybe needed for multiproto:
209 #sed -i Makefile \
210 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
211 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
212
213 if ! grep -q APIVERSION Makefile; then
214 ebegin " Converting to APIVERSION"
215 sed -i Makefile \
216 -e 's:^APIVERSION = :APIVERSION ?= :' \
217 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
218 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
219 eend $?
220 fi
221
222 # Correcting Compile-Flags
223 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
224 sed -i Makefile \
225 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
226 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
227
228 # Disabling file stripping, useful for debugging
229 sed -i Makefile \
230 -e '/@.*strip/d' \
231 -e '/strip \$(LIBDIR)\/\$@/d' \
232 -e '/@.*\$(STRIP)/d'
233
234 # Use a file instead of a variable as single-stepping via ebuild
235 # destroys environment.
236 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
237}
238
239vdr_add_local_patch() {
240 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
241 echo
242 einfo "Applying local patches"
243 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
244 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
245 done
246 fi
247}
248
249vdr_has_gettext() {
250 has_version ">=media-video/vdr-1.5.7"
251}
252
253plugin_has_gettext() {
254 [[ -d po ]]
255}
256
257vdr_i18n_convert_to_gettext() {
258 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
259
260 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
261 ewarn "Conversion to gettext disabled in ebuild"
262 return 1
263 fi
264
265 if [[ ! -x ${i18n_tool} ]]; then
266 eerror "Missing ${i18n_tool}"
267 eerror "Please re-emerge vdr"
268 die "Missing ${i18n_tool}"
269 fi
270
271 ebegin "Auto converting translations to gettext"
272 # call i18n-to-gettext tool
273 # take all texts missing tr call into special file
274 "${i18n_tool}" 2>/dev/null \
275 |sed -e '/^"/!d' \
276 -e '/^""$/d' \
277 -e 's/\(.*\)/trNOOP(\1)/' \
278 > dummy-translations-trNOOP.c
279
280 # if there were untranslated texts just run it again
281 # now the missing calls are listed in
282 # dummy-translations-trNOOP.c
283 if [[ -s dummy-translations-trNOOP.c ]]; then
284 "${i18n_tool}" &>/dev/null
285 fi
286
287 # now use the modified Makefile
288 if [[ -f Makefile.new ]]; then
289 mv Makefile.new Makefile
290 eend 0 ""
291 else
292 eend 1 "Conversion to gettext failed. Plugin needs fixing."
293 return 1
294 fi
295}
296
297vdr_i18n_disable_gettext() {
298 ebegin "Disabling gettext support in plugin"
299 # Remove i18n Target if using older vdr
300 sed -i Makefile \
301 -e '/^all:/s/ i18n//'
302 eend 0
303}
304
305vdr_i18n() {
306 if vdr_has_gettext; then
307 einfo "VDR has gettext support"
308 if plugin_has_gettext; then
309 einfo "Plugin has gettext support, fine"
310 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
311 ewarn "Please remove left over NO_GETTEXT_HACK."
312 fi
313 else
314 vdr_i18n_convert_to_gettext
315 if [[ $? != 0 ]]; then
316 eerror ""
317 eerror "Plugin will have only english OSD texts"
318 eerror "it needs manual fixing."
319 fi
159 fi 320 fi
321 else
322 einfo "VDR has no gettext support"
323 if plugin_has_gettext; then
324 vdr_i18n_disable_gettext
160 fi 325 fi
326 fi
161} 327}
328
329vdr-plugin_copy_source_tree() {
330 pushd . >/dev/null
331 cp -r "${S}" "${T}"/source-tree
332 cd "${T}"/source-tree
333 cp "${WORKDIR}"/Makefile.before Makefile
334 # TODO: Fix this, maybe no longer needed
335 sed -i Makefile \
336 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
337 -e 's:^CXXFLAGS:#CXXFLAGS:' \
338 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
339 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
340 popd >/dev/null
341}
342
343vdr-plugin_install_source_tree() {
344 einfo "Installing sources"
345 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
346 insinto "${destdir}-${PV}"
347 doins -r "${T}"/source-tree/*
348
349 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
350}
351
352vdr-plugin_print_enable_command() {
353 local p_name c=0 l=""
354 for p_name in ${vdr_plugin_list}; do
355 c=$(( c+1 ))
356 l="$l ${p_name#vdr-}"
357 done
358
359 elog
360 case $c in
361 1) elog "Installed plugin${l}" ;;
362 *) elog "Installed $c plugins:${l}" ;;
363 esac
364 elog "To activate a plugin execute this command:"
365 elog "\teselect vdr-plugin enable <plugin_name> ..."
366 elog
367}
368
369has_vdr() {
370 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
371}
372
373## exported functions
162 374
163vdr-plugin_pkg_setup() { 375vdr-plugin_pkg_setup() {
164 # -fPIC is needed for shared objects on some platforms (amd64 and others) 376 # -fPIC is needed for shared objects on some platforms (amd64 and others)
165 append-flags -fPIC 377 append-flags -fPIC
166 378
174 386
175 # Pathes to includes 387 # Pathes to includes
176 VDR_INCLUDE_DIR="/usr/include/vdr" 388 VDR_INCLUDE_DIR="/usr/include/vdr"
177 DVB_INCLUDE_DIR="/usr/include" 389 DVB_INCLUDE_DIR="/usr/include"
178 390
391 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
392 LOCDIR="/usr/share/vdr/locale"
179 393
394 if ! has_vdr; then
395 # set to invalid values to detect abuses
396 VDRVERSION="eclass_no_vdr_installed"
397 APIVERSION="eclass_no_vdr_installed"
398
399 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
400 einfo "VDR not found!"
401 else
402 # if vdr is required
403 die "VDR not found!"
404 fi
405 return
406 fi
407
180 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 408 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
181 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 409 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
182 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 410 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
183 411
184 einfo "Building ${PF} against vdr-${VDRVERSION}" 412 einfo "Compiling against"
185 einfo "APIVERSION: ${APIVERSION}" 413 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
414}
415
416vdr-plugin_src_util() {
417
418 while [ "$1" ]; do
419
420 case "$1" in
421 all)
422 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
423 ;;
424 prepare|all_but_unpack)
425 vdr-plugin_src_util add_local_patch patchmakefile i18n
426 ;;
427 unpack)
428 base_src_unpack
429 ;;
430 add_local_patch)
431 cd "${S}" || die "Could not change to plugin-source-directory!"
432 vdr_add_local_patch
433 ;;
434 patchmakefile)
435 cd "${S}" || die "Could not change to plugin-source-directory!"
436 vdr_patchmakefile
437 ;;
438 i18n)
439 cd "${S}" || die "Could not change to plugin-source-directory!"
440 vdr_i18n
441 ;;
442 esac
443
444 shift
445 done
186} 446}
187 447
188vdr-plugin_src_unpack() { 448vdr-plugin_src_unpack() {
189 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 449 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
190 eerror "Wrong use of vdr-plugin.eclass." 450 eerror "Wrong use of vdr-plugin.eclass."
191 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 451 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
192 echo 452 echo
193 eerror "Please report this at bugs.gentoo.org." 453 eerror "Please report this at bugs.gentoo.org."
194 die "vdr-plugin_pkg_setup not called!" 454 die "vdr-plugin_pkg_setup not called!"
195 fi 455 fi
196 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile 456 if [ -z "$1" ]; then
457 case "${EAPI:-0}" in
458 2)
459 vdr-plugin_src_util unpack
460 ;;
461 *)
462 vdr-plugin_src_util all
463 ;;
464 esac
465
466 else
467 vdr-plugin_src_util $@
468 fi
469}
470
471vdr-plugin_src_prepare() {
472 base_src_prepare
473 vdr-plugin_src_util prepare
474}
475
476vdr-plugin_src_compile() {
477 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
197 478
198 while [ "$1" ]; do 479 while [ "$1" ]; do
199 480
200 case "$1" in 481 case "$1" in
201 all_but_unpack) 482 copy_source)
202 vdr-plugin_src_unpack add_local_patch patchmakefile
203 ;;
204 unpack)
205 base_src_unpack
206 ;;
207 patchmakefile)
208 if ! cd ${S}; then
209 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
210 ewarn "Perhaps you find one among these:"
211 cd "${WORKDIR}"
212 ewarn "$(/bin/ls -1 ${WORKDIR})"
213 die "Could not change to plugin-source-directory!"
214 fi
215
216 einfo "Patching Makefile"
217 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
218 cp Makefile "${WORKDIR}"/Makefile.before
219
220 sed -i Makefile \
221 -e '1i\#Makefile was patched by vdr-plugin.eclass'
222
223 ebegin " Setting Pathes"
224 sed -i Makefile \
225 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
226 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
227 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
228 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
229 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
230 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
231 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
232 eend $?
233
234 ebegin " Converting to APIVERSION"
235 sed -i Makefile \
236 -e 's:^APIVERSION = :APIVERSION ?= :' \
237 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
238 -e '2i\APIVERSION = '"${APIVERSION}"
239 eend $?
240
241 ebegin " Correcting Compile-Flags"
242 sed -i Makefile \
243 -e 's:^CXXFLAGS:#CXXFLAGS:' \
244 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
245 eend $?
246
247 ebegin " Disabling file stripping"
248 sed -i Makefile \
249 -e '/@.*strip/d' \
250 -e '/strip \$(LIBDIR)\/\$@/d' \
251 -e '/^STRIP =/d' \
252 -e '/@.*\$(STRIP)/d'
253 eend $?
254
255 # Use a file instead of an variable as single-stepping via ebuild
256 # destroys environment.
257 touch ${WORKDIR}/.vdr-plugin_makefile_patched
258 ;;
259 add_local_patch)
260 cd ${S}
261 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
262 echo
263 einfo "Applying local patches"
264 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
265 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
266 done
267 fi
268 ;;
269 esac
270
271 shift
272 done
273}
274
275vdr-plugin_copy_source_tree() {
276 pushd . >/dev/null
277 cp -r ${S} ${T}/source-tree
278 cd ${T}/source-tree
279 cp "${WORKDIR}"/Makefile.before Makefile
280 sed -i Makefile \
281 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
282 -e 's:^CXXFLAGS:#CXXFLAGS:' \
283 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
284 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
285 popd >/dev/null
286}
287
288vdr-plugin_install_source_tree() {
289 einfo "Installing sources"
290 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
291 insinto ${destdir}-${PV}
292 doins -r ${T}/source-tree/*
293
294 dosym ${VDRPLUGIN}-${PV} ${destdir}
295}
296
297vdr-plugin_src_compile() {
298 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
299
300 while [ "$1" ]; do
301
302 case "$1" in
303 prepare)
304 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 483 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
305 ;; 484 ;;
306 compile) 485 compile)
307 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then 486 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
308 eerror "Wrong use of vdr-plugin.eclass." 487 eerror "Wrong use of vdr-plugin.eclass."
310 eerror "calling vdr-plugin_src_unpack to patch the Makefile." 489 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
311 echo 490 echo
312 eerror "Please report this at bugs.gentoo.org." 491 eerror "Please report this at bugs.gentoo.org."
313 die "vdr-plugin_src_unpack not called!" 492 die "vdr-plugin_src_unpack not called!"
314 fi 493 fi
315 cd ${S} 494 cd "${S}"
316 495
317 emake ${BUILD_PARAMS} ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed" 496 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
497
498 emake ${BUILD_PARAMS} \
499 ${BUILD_TARGETS} \
500 LOCALEDIR="${TMP_LOCALE_DIR}" \
501 LIBDIR="${S}" \
502 TMPDIR="${T}" \
503 || die "emake failed"
318 ;; 504 ;;
319 esac 505 esac
320 506
321 shift 507 shift
322 done 508 done
325vdr-plugin_src_install() { 511vdr-plugin_src_install() {
326 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree 512 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
327 cd "${WORKDIR}" 513 cd "${WORKDIR}"
328 514
329 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then 515 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
330 local mname=${P}-Makefile 516 local mname="${P}-Makefile"
331 cp "${S}"/Makefile ${mname}.patched 517 cp "${S}"/Makefile "${mname}.patched"
332 cp Makefile.before ${mname}.before 518 cp Makefile.before "${mname}.before"
333 519
334 diff -u ${mname}.before ${mname}.patched > ${mname}.diff 520 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
335 521
336 insinto "/usr/share/vdr/maintainer-data/makefile-changes" 522 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
337 doins ${mname}.diff 523 doins "${mname}.diff"
338 524
339 insinto "/usr/share/vdr/maintainer-data/makefile-before" 525 insinto "/usr/share/vdr/maintainer-data/makefile-before"
340 doins ${mname}.before 526 doins "${mname}.before"
341 527
342 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 528 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
343 doins ${mname}.patched 529 doins "${mname}.patched"
344 530
345 fi 531 fi
532
533
346 534
347 cd "${S}" 535 cd "${S}"
348 insinto "${VDR_PLUGIN_DIR}" 536 insinto "${VDR_PLUGIN_DIR}"
349 doins libvdr-*.so.* 537 doins libvdr-*.so.*
538
539 # create list of all created plugin libs
540 vdr_plugin_list=""
541 local p_name
542 for p in libvdr-*.so.*; do
543 p_name="${p%.so*}"
544 p_name="${p_name#lib}"
545 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
546 done
547
548 create_header_checksum_file ${vdr_plugin_list}
549 create_plugindb_file ${vdr_plugin_list}
550
551 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
552 einfo "Installing locales"
553 cd "${TMP_LOCALE_DIR}"
554 insinto "${LOCDIR}"
555 doins -r *
556 fi
557
558 cd "${S}"
350 local docfile 559 local docfile
351 for docfile in README* HISTORY CHANGELOG; do 560 for docfile in README* HISTORY CHANGELOG; do
352 [[ -f ${docfile} ]] && dodoc ${docfile} 561 [[ -f ${docfile} ]] && dodoc ${docfile}
353 done 562 done
354 563
365 574
366 if [[ -n ${VDR_RCADDON_FILE} ]]; then 575 if [[ -n ${VDR_RCADDON_FILE} ]]; then
367 insinto "${VDR_RC_DIR}" 576 insinto "${VDR_RC_DIR}"
368 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 577 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
369 fi 578 fi
370
371 create_header_checksum_file
372 create_plugindb_file
373} 579}
374 580
375vdr-plugin_pkg_postinst() { 581vdr-plugin_pkg_postinst() {
376 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then 582 vdr-plugin_print_enable_command
377 update_vdrplugindb 583
378 fi
379 elog
380 elog "The vdr plugin ${VDRPLUGIN} has now been installed."
381 elog "To activate execute the following command:"
382 elog
383 elog " emerge --config ${PN}"
384 elog
385 if [[ -n "${VDR_CONFD_FILE}" ]]; then 584 if [[ -n "${VDR_CONFD_FILE}" ]]; then
386 elog "And have a look at the config-file" 585 elog "Please have a look at the config-file"
387 elog "/etc/conf.d/vdr.${VDRPLUGIN}" 586 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
388 elog 587 elog
389 fi 588 fi
390} 589}
391 590
392vdr-plugin_pkg_postrm() { 591vdr-plugin_pkg_postrm() {
393 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
394 remove_vdrplugindb
395 fi
396 delete_orphan_plugindb_file 592 delete_orphan_plugindb_file
397} 593}
398 594
399vdr-plugin_pkg_config_final() {
400 diff ${conf_orig} ${conf}
401 rm ${conf_orig}
402}
403
404vdr-plugin_pkg_config_old() {
405 elog "Using interface of gentoo-vdr-scripts-0.3.6 and older"
406 if [[ -z "${INSTALLPLUGIN}" ]]; then
407 INSTALLPLUGIN="${VDRPLUGIN}"
408 fi
409 # First test if plugin is already inside PLUGINS
410 local conf=/etc/conf.d/vdr
411 conf_orig=${conf}.before_emerge_config
412 cp ${conf} ${conf_orig}
413
414 elog "Reading ${conf}"
415 if ! grep -q "^PLUGINS=" ${conf}; then
416 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
417 if [[ -n "${LINE}" ]]; then
418 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
419 else
420 echo 'PLUGINS=""' >> ${conf}
421 fi
422 unset LINE
423 fi
424
425 unset PLUGINS
426 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
427
428 active=0
429 for p in ${PLUGINS}; do
430 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
431 active=1
432 break;
433 fi
434 done
435
436 if [[ "${active}" == "1" ]]; then
437 elog "${INSTALLPLUGIN} already activated"
438 echo
439 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
440 if [[ "${answer}" != "yes" ]]; then
441 elog "aborted"
442 return
443 fi
444 elog "Removing ${INSTALLPLUGIN} from active plugins."
445 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
446 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
447 -e ${LINE}'s/ \( \)*/ /g' \
448 -e ${LINE}'s/ "/"/g' \
449 -e ${LINE}'s/" /"/g'
450
451 vdr-plugin_pkg_config_final
452 return
453 fi
454
455
456 elog "Adding ${INSTALLPLUGIN} to active plugins."
457 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
458 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
459 -e ${LINE}'s/ \( \)*/ /g' \
460 -e ${LINE}'s/ "/"/g' \
461 -e ${LINE}'s/" /"/g'
462
463 vdr-plugin_pkg_config_final
464}
465
466vdr-plugin_pkg_config_new() {
467 elog "Using interface introduced with gentoo-vdr-scripts-0.3.7"
468 if [[ -z "${INSTALLPLUGIN}" ]]; then
469 INSTALLPLUGIN="${VDRPLUGIN}"
470 fi
471
472 active=0
473 # First test if plugin is already inside PLUGINS
474 local conf=/etc/conf.d/vdr.plugins
475 exec 3<${conf}
476 while read -u 3 line; do
477 [[ ${line} == "" ]] && continue
478 [[ ${line:0:1} == "#" ]] && continue
479 set -- ${line}
480 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
481 done
482 exec 3<&-
483
484 if [[ $active == 0 ]]; then
485 elog "Adding ${INSTALLPLUGIN} to active plugins."
486
487 # The pure edit process.
488 echo "${INSTALLPLUGIN}" >> "${conf}"
489 else
490 elog "${INSTALLPLUGIN} already activated"
491 echo
492 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
493 if [[ "${answer}" != "yes" ]]; then
494 elog "aborted"
495 return
496 fi
497 elog "Removing ${INSTALLPLUGIN} from active plugins."
498
499 # The pure edit process
500 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
501 fi
502}
503
504vdr-plugin_pkg_config() { 595vdr-plugin_pkg_config() {
505 if has_version ">media-tv/gentoo-vdr-scripts-0.3.6"; then 596 ewarn "emerge --config ${PN} is no longer supported"
506 vdr-plugin_pkg_config_new 597 vdr-plugin_print_enable_command
507 else
508 vdr-plugin_pkg_config_old
509 fi
510} 598}
511 599
512fix_vdr_libsi_include() 600case "${EAPI:-0}" in
513{ 601 2)
514 einfo "Fixing include of libsi-headers" 602 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
515 local f 603 ;;
516 for f; do 604 *)
517 sed -i "${f}" \
518 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
519 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
520 done
521}
522
523EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 605 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
606 ;;
607esac

Legend:
Removed from v.1.47  
changed lines
  Added in v.1.69

  ViewVC Help
Powered by ViewVC 1.1.20